<?php

class jwtVerifier {
    private $secret;
    private $apiJwt;
    private $apiKey;
    private $apiClient;
    private $apiPayload;
    private $apiResponse;
    private $apiExpiration;
    private $apiEndTime = 120; //Seconds
    public $file;
    public $class;

    /**
     * 
     * PAYLOAD RECEIVER
     * {
     *      "controller": {
     *          "starts": 1695126939,
     *          "client": "CasaDaBateria",
     *          "version": "v1",
     *          "apiKey": "24b2675194cc1e32398dcb4646060d56f76e2e189331f51dd617125e57e88479"
     *      },
     *      "parameters": {
     *          "feature": "getInputCallDate",
     *          "date": "2023-09-19",
     *          "phone": "8140022122"
     *      }
     *  }
     * 
     * 
     */

    public function __construct($apiJwt) 
    {
        $this->apiJwt = $apiJwt;
        //$this->validateToken();
        
        $this->decodeToken();
        $this->validateSecretKey();
        $this->isTokenExpired();
        $this->jwtResponse();
    }

    private function setApiStart($apiStart)
    {
        $this->apiStart = $apiStart;
    }

    private function setApiClient($apiClient)
    {
        $this->apiClient = $apiClient;
    }

    private function setApiExpiration($start)
    {
        $this->apiExpiration = $start + $this->apiEndTime;
    }

    private function getApiExpiration()
    {
        return $this->apiExpiration;
    }

    private function setApiPayload($apiPayload)
    {
        $this->apiPayload = $apiPayload;
    }

    private function setSecret($client)
    {
        $file = __DIR__ . "/clients/$client" . ".php";
        
        if (file_exists($file)) {
            
            //Set Attributes
            $this->file = $file;
            $this->class = $client;

            require_once $file;
            $this->secret = $client::getApiKey();
        } else {            
            $this->jwtError("Parâmetros inválidos");
        }
    }

    private function setApiKey($apiKey)
    {
        $this->apiKey = $apiKey;
    }

    private function decodeToken()
    {
        //Decode Jwt prepare vars ---------------------------------------------------
        $payload = json_decode(base64_decode(explode('.', $this->apiJwt)[1]), true);
        $apiClient = $payload['controller']['client'];
        $apiStart  = $payload['controller']['starts'];
        //---------------------------------------------------------------------------

        //Set attributes ------------------------------------
        $this->setApiPayload($payload);
        $this->setSecret($apiClient);
        $this->setApiClient($apiClient);
        $this->setApiExpiration($apiStart);
        // Prepare apiKey
        $apiKey = hash('sha256', $apiStart . $this->secret);
        $this->setApiKey($apiKey);
        //---------------------------------------------------
    }

    private function validateSecretKey() 
    {
        // Compare a chave secreta fornecida com a chave secreta esperada
        if (!($this->apiKey === $this->apiPayload['controller']['apiKey'])){
            $this->jwtError("Token de autenticação inválido");
        }
    }

    private function isTokenExpired() 
    {
        //print_r(json_encode($this->getApiExpiration()));die;
        // Obtém a data atual em formato de timestamp
        $newDateTime = new DateTime();
        $currentTime = $newDateTime->getTimestamp();
    
        // Verifica se a data de expiração é menor que a data atual
        if($this->getApiExpiration() < $currentTime){
            $this->jwtError("Token de autenticação expirado");
        }
    }

    private function jwtError($error)
    {
        header("HTTP/1.0 401 Unauthorized -> $error");
        print_r(json_encode($error));
        die;
    }

    public function jwtResponse()
    {
        return true;
        
    }
    public function getClientRequest()
    {
        return $this->apiPayload;
        
    }
}