<?php

class v1 {

    public static $DB1;
    public static $DB2;

    public static function getConn()
    {
        self::$DB1 = self::connect('asterisk');
        self::$DB2 = self::connect('asteriskcdrdb');
    }

    public static function connect($db)
    {
        $dsn = "mysql:host=localhost; port=5432; dbname=$db";
        $username = 'root';
        $password = 'passw0rd';
        $options = array(
            PDO::MYSQL_ATTR_INIT_COMMAND => 'SET NAMES utf8',
        );
        return new PDO($dsn, $username, $password, $options);
    }

    public static function getICallDate($data)
    {

        $return = [];
        $return['inbound'] = self::getInboundCallDate($data);
        $return['outbound'] = self::getOutboundCallDate($data);
        return $return;
        
    }
    public static function getInboundCallDate($data)
    {
        self::getConn();
        $db = self::$DB2;
        

        $phone = $data['phone'];
        $date  = $data['date'];
        $accountcode  = $data['accountcode'];
        $firstdst = '55'.$phone;
        
        $sql="  SELECT 
                    ID as id,
                    src,
                    duration,
                    lastdst, 
                    TIME(start) as start,
                    TIME(end) as end
                FROM 
                    cdr
                WHERE
                    firstdst = :firstdst
                AND 
                    accountcode = :accountcode
                AND
                    DATE(start) = :start
                AND 
                    disposition = :disposition
                AND 
                    duration > :duration
                AND
                    dcontext = :dcontext
                ORDER BY 
                    ID ASC;
        ";
        //SELECT ID as id, src, duration, lastdst, TIME(start) as start, TIME(end) as end FROM cdr WHERE firstdst = '40022122' AND accountcode = 20211 AND DATE(start) = '2023-08-31' AND disposition = 'ANSWERED' AND duration > 15 AND LENGTH(lastdst) > '4' ORDER BY ID ASC;
        $stmt = $db->prepare($sql);
        $stmt->bindValue(":firstdst", $firstdst);
        $stmt->bindValue(":accountcode", $accountcode);
        $stmt->bindValue(":start", $date);
        $stmt->bindValue(":disposition", 'ANSWERED');
        $stmt->bindValue(":duration", 0);
        $stmt->bindValue(":dcontext", 'fromotherpbx');
        $stmt->execute();
        return $stmt->fetchAll(\PDO::FETCH_ASSOC);
    }

    public static function getOutboundCallDate($data)
    {
        self::getConn();
        $db = self::$DB2;

        $date  = $data['date'];
        $teId  = 1;
        
        $sql="  SELECT  
                    SUBSTR(sc_whoanswered, 3) AS 'Destino'
                FROM 
                    sc_simplecdr 
                WHERE 
                    LENGTH(sc_whoanswered) > :sc_whoanswered
                AND
                    sc_direction = :sc_direction
                AND 
                    sc_te_id = :sc_te_id
                AND 
                    DATE(sc_start) = :sc_start
        ";
        //SELECT SUBSTR(sc_whoanswered, 3) AS 'Destino' FROM sc_simplecdr WHERE LENGTH(sc_whoanswered) > '6' AND sc_direction = 'OUT' AND sc_te_id = '1' AND DATE(sc_start) = ''
        $stmt = $db->prepare($sql);
        $stmt->bindValue(":sc_whoanswered", 6);
        $stmt->bindValue(":sc_direction", 'OUT');
        $stmt->bindValue(":sc_te_id", $teId);
        $stmt->bindValue(":sc_start", $date);
        $stmt->execute();
        return $stmt->fetchAll(\PDO::FETCH_ASSOC);
    }

    public static function getClientDid($data)
    {
        self::getConn();
        $db = self::$DB1;
        $tenantId  = $data['tenantId'];

        $sql = "SELECT di_id, di_country, di_area, di_number, di_comment FROM di_dids WHERE di_te_id = :di_te_id ORDER BY di_comment";
        $stmt = $db->prepare($sql);
        $stmt->bindValue(":di_te_id", $tenantId);
        $stmt->execute();
        return $stmt->fetchAll(\PDO::FETCH_ASSOC);
    }

    
}